POJ-3126-Prime Path-素数-BFS
发布日期:2022-02-10 08:11:09 浏览次数:9 分类:技术文章

本文共 3568 字,大约阅读时间需要 11 分钟。

Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

31033 81791373 80171033 1033

Sample Output

670

题意:将一个素数变成另一个素数,且每次只能变一个数字,而且变成的数字也必须是素数,问最少要多少步

解题思路:首先是判断素数,可以用埃式筛法做一个素数表,方便查询,然后可以用BFS求最小步数

AC代码:#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#define maxn 10005typedef long long ll;using namespace std;typedef pair
P;int prime[maxn],ans,n;bool is_prime[maxn];int main(){ ans=0; for(int i=0; i<=maxn; i++) is_prime[i]=true; is_prime[0]=is_prime[1]=false; for(int i=2; i<=maxn; i++) //埃式筛法 { if(is_prime[i]) { prime[ans++]=i; //可以顺便把所有素数保存在数组中,本题其实不需要 for(int j=i*2; j<=maxn; j+=i) is_prime[j]=false; } } cin>>n; while(n--) { int a,b,sum; scanf("%d%d",&a,&b); queue

que; //pair函数和队列的连用 sum=0; que.push(P(a,sum)); //保存当前数字和步数 int vis[10000]; memset(vis,0,sizeof(vis)); while(!que.empty()) { P x=que.front(); if(x.first==b) break; que.pop(); vis[x.first]=1; //标记用过的数字,防止出现死循环 for(int i=0;i<=9;i++) //改变个位数字 { int y=x.first/10*10+i; if(is_prime[y]&&!vis[y]) que.push(P(y,x.second+1)); } for(int i=0;i<=9;i++) //十位 { int y=x.first%10+x.first/100*100+i*10; if(is_prime[y]&&!vis[y]) que.push(P(y,x.second+1)); } for(int i=0;i<=9;i++) //百位 { int y=x.first%10+x.first%100/10*10+x.first/1000*1000+i*100; if(is_prime[y]&&!vis[y]) que.push(P(y,x.second+1)); } for(int i=1;i<=9;i++) //千位,注意不能为0 { int y=x.first%1000+i*1000; if(is_prime[y]&&!vis[y]) que.push(P(y,x.second+1)); } } if(que.empty()) printf("Impossible\n"); else printf("%d\n",que.front().second); } return 0;}

**如果有疑问或更好的方法欢迎大家留言( ̄︶ ̄)↗ **

转载地址:https://blog.csdn.net/qq_44632981/article/details/97817357 如侵犯您的版权,请留言回复原文章的地址,我们会给您删除此文章,给您带来不便请您谅解!

上一篇:HDU-1847 Good Luck in CET-4 Everybody!-博弈-SG函数
下一篇:POJ-2991-Crane -线段树

发表评论

最新留言

初次前来,多多关照!
[***.217.46.12]2024年04月17日 01时22分45秒